// Generated by dts-bundle v0.7.3



/**
  * - SOLO_QUEUE: ranked solo queue on summoners rift
  * - FLEX_QUEUE: ranked flex queue on summoners rift
  * - SOLO_THREE: ranked flex queue on twisted treeline
  */
export enum Queues {
    SOLO_QUEUE = "RANKED_SOLO_5x5",
    FLEX_QUEUE = "RANKED_FLEX_SR",
    FLEX_THREE = "RANKED_FLEX_TT"
}

export enum Regions {
    EUW = "euw1",
    EUNE = "eun1",
    TR = "tr1",
    NA = "na1",
    LAN = "la1",
    BR = "br1",
    OCE = "oc1",
    JP = "jp1",
    KR = "kr",
    RU = "ru"
}

/**
  * Champion Rotation
  */
export interface ChampionRotation {
    readonly freeChampions: RotationChampion[];
    readonly freeChampionsForNewPlayers: RotationChampion[];
    readonly maximumNewPlayerLevel: number;
}

/**
  * Champion that is in a Rotation
  */
export interface RotationChampion {
    readonly id: number;
}

/**
    * Summoner's mastery in a Champion
    */
export interface ChampionMastery {
        readonly chestGranted: boolean;
        readonly level: number;
        readonly points: number;
        readonly id: number;
        readonly summonerId: string;
        readonly pointsUntilNextLevel: number;
        readonly pointsSinceLastLevel: number;
        readonly lastPlayTime: number;
        /**
            * Gets the Summoner from the ChampionMastery
            */
        getSummoner(): Promise<Summoner>;
}

export interface LeagueItem {
    readonly rank: string;
    readonly hotStreak: boolean;
    readonly miniSeries?: MiniSeries | null;
    readonly wins: number;
    readonly veteran: boolean;
    readonly losses: number;
    readonly freshBlood: boolean;
    readonly summonerName: string;
    readonly inactive: boolean;
    readonly summonerId: string;
    readonly leaguePoints: number;
    /**
      * gets the Summoner from the ChampionMastery
      */
    getSummoner(): Promise<Summoner>;
}

export interface LeagueList {
    readonly leagueId: string;
    readonly tier: string;
    readonly entries: LeagueItem[];
    readonly queue: string;
    readonly name: string;
}

export interface LeaguePosition {
    readonly rank: string;
    readonly queueType: string;
    readonly hotStreak: boolean;
    readonly miniSeries: MiniSeries | null;
    readonly wins: number;
    readonly veteran: boolean;
    readonly losses: number;
    readonly freshBlood: boolean;
    readonly leagueId: string;
    readonly summonerName: string;
    readonly inactive: boolean;
    readonly summonerId: string;
    readonly tier: string;
    readonly leaguePoints: number;
    /**
      * gets the Summoner from the ChampionMastery
      */
    getSummoner(): Promise<Summoner>;
}

export interface MiniSeries {
    readonly wins: number;
    readonly losses: number;
    readonly target: number;
    readonly progress: string;
}

export interface TeamBan {
    pickTurn: number;
    championId: number;
}

export interface DamageDealtStats {
    trueDamageDealt: number;
    totalDamageDealt: number;
    magicDamageDealt: number;
    physicalDamageDealt: number;
    trueDamageDealtToChampions: number;
    totalDamageDealtToChampions: number;
    magicDamageDealtToChampions: number;
    physicalDamageDealtToChampions: number;
}

export interface DamageTakenStats {
    trueDamageTaken: number;
    totalDamageTaken: number;
    magicalDamageTaken: number;
    physicalDamageTaken: number;
    damageSelfMitigated: number;
}

export interface ExtraStat {
    id: number;
}

export interface FirstStats {
    firstBloodKill: boolean;
    firstBloodAssist: boolean;
    firstTowerKill: boolean;
    firstTowerAssist: boolean;
    firstInhibitorKill: boolean;
    firstInhibitorAssist: boolean;
}

export interface Match {
    id: number;
    teams: Team[];
    mapId: number;
    queueId: number;
    seasonId: number;
    gameMode: string;
    gameType: string;
    platformId: string;
    gameVersion: string;
    gameCreation: number;
    gameDuration: number;
    participants: Participant[];
}

export interface MatchList {
    endIndex: number;
    startIndex: number;
    totalGames: number;
    matches: MatchReference[];
}

export interface MatchReference {
    role: string;
    lane: string;
    matchId: number;
    queueId: number;
    seasonId: number;
    timestamp: number;
    platformId: string;
    championId: number;
}

export interface MinionStats {
    totalMinionsKilled: number;
    neutralMinionsKilled: number;
    neutralMinionsKilledTeamJungle: number;
    neutralMinionsKilledEnemyJungle: number;
}

export interface MiscStats {
    totalHeal: number;
    killingSprees: number;
    totalUnitsHealed: number;
    largestKillingSpree: number;
    largestCriticalStrike: number;
    longestTimeSpentLiving: number;
    totalTimeCrowdControlDealt: number;
}

export interface MultiKillStats {
    hexaKills: number;
    pentaKills: number;
    quadraKills: number;
    tripleKills: number;
    doubleKills: number;
}

export interface ObjectiveStats {
    goldSpent: number;
    goldEarned: number;
    visionScore: number;
    turretKills: number;
    wardsPlaced: number;
    wardsKilled: number;
    inhibitorKills: number;
    timeCCingOthers: number;
    damageDealtToTurrets: number;
    sightWardsBoughtInGame: number;
    damageDealtToObjectives: number;
    visionWardsBoughtInGame: number;
}

export interface Participant {
    stats: Stats;
    teamId: number;
    player: Player;
    spells: Map<number, number>;
    timeline: Timeline;
    championId: number;
    participantId: number;
    highestAchievedSeasonTier: string;
}

export interface Player {
    accountId: string;
    platformId: string;
    summonerId: string;
    profileIcon: number;
    summonerName: string;
    matchHistoryUri: string;
    currentAccountId: string;
    currentPlatformId: string;
}

export interface PrimaryTree {
    keystone: Rune;
    style: number;
    rune1: Rune;
    rune2: Rune;
    rune3: Rune;
}

export interface Rune {
    id: number;
    vars: Map<number, number>;
}

export interface RunePage {
    primary: PrimaryTree;
    secondary: SecondaryTree;
    stats: Map<number, ExtraStat>;
}

export interface ScoreStats {
    totalScoreRank: number;
    totalPlayerScore: number;
    combatPlayerScore: number;
    objectivePlayerScore: number;
    playerScores: Map<number, number>;
}

export interface SecondaryTree {
    style: number;
    rune1: Rune;
    rune2: Rune;
}

export interface Stats {
    participantId: number;
    runePage: RunePage;
    win: boolean;
    trinket: number;
    items: Map<number, number>;
    kills: number;
    deaths: number;
    assists: number;
    champLevel: number;
    misc: MiscStats;
    first: FirstStats;
    scores: ScoreStats;
    objective: ObjectiveStats;
    damageTaken: DamageTakenStats;
    damageDealt: DamageDealtStats;
}

export interface Team {
    win: boolean;
    bans: TeamBan[];
    teamId: number;
    firstBlood: boolean;
    firstTower: boolean;
    firstBaron: boolean;
    baronKills: number;
    towerKills: number;
    dragonKills: number;
    firstDragon: boolean;
    vilemawKills: number;
    firstInhibitor: boolean;
    inhibitorKills: number;
    firstRiftHerald: boolean;
    riftHeraldKills: number;
    dominionVictoryScore: number;
}

export interface Timeline {
    role: string;
    lane: string;
    participantId: number;
    xpPerMinDeltas: Map<string, number>;
    goldPerMinDeltas: Map<string, number>;
    creepsPerMinDeltas: Map<string, number>;
    csDiffPerMinDeltas: Map<string, number>;
    xpDiffPerMinDeltas: Map<string, number>;
    damageTakenPerMinDeltas: Map<string, number>;
    damageTakenDiffPerMinDeltas: Map<string, number>;
}

export interface Incident {
    readonly active: boolean;
    readonly createdAt: Date;
    readonly id: number;
    readonly updates: Message[];
}

export interface Message {
    readonly severity: string;
    readonly author: string;
    readonly createdAt: string;
    readonly translations: Translation[];
    readonly updatedAt: string;
    readonly content: string;
    readonly id: string;
}

export interface Service {
    readonly status: string;
    readonly incidents: Incident[];
    readonly name: string;
    readonly slug: string;
}

export interface Shard {
    readonly name: string;
    readonly slug: string;
    readonly locales: string[];
    readonly hostname: string;
    readonly regionTag: string;
    readonly services: Service[];
}

export interface Translation {
    readonly locale: string;
    readonly content: string;
    readonly heading: string;
}

/**
  * Summoner's Profile Icon
  */
export interface ProfileIcon {
    readonly id: number;
    getURL(patch: string): string;
}

/**
  * Summoner
  */
export interface Summoner {
    readonly id: string;
    readonly accountId: string;
    readonly name: string;
    readonly profileIcon: ProfileIcon;
    readonly level: number;
    readonly revisionDate: Date;
}

/**
    * Champion Wrapper
    */
export interface ChampionWrapper {
        /**
            * Gets the current Champion Rotation
            *
            * @param region - (optional) region
            */
        getChampionsInfo(region?: Regions): Promise<ChampionRotation>;
}

/**
    * Champion Mastery Wrapper
    */
export interface ChampionMasteryWrapper {
        /**
            * Gets Champion Masteries
            *
            * @param summonerId - ID of the summoner in question
            * @param championId - (optional) specific champion
            * @param region - (optional) region
            */
        getChampionMasteries(summonerId: string, championId?: number, region?: Regions): Promise<ChampionMastery[]>;
        /**
            * Gets the total mastery score of a summoner
            *
            * @param summonerId - ID of the summoner in question
            * @param region - (optional) region
            */
        getChampionMasteryScore(summonerId: string, region?: Regions): Promise<number>;
}

/**
    * League Wrapper
    */
export interface LeagueWrapper {
        /**
            * Gets the challenger ladder
            *
            * @param queue - queue
            * @param region - (optional) region
            */
        getChallengerLeague(queue: Queues, region?: Regions): Promise<LeagueList>;
        /**
            * Gets the master ladder
            *
            * @param queue - queue
            * @param region - (optional) region
            */
        getMasterLeague(queue: Queues, region?: Regions): Promise<LeagueList>;
        /**
            * Gets the ladder of a league
            *
            * @param leagueId - ID of the league
            * @param region - (optional) region
            */
        getLeague(leagueId: string, region?: Regions): Promise<LeagueList>;
        /**
            * Gets the ranks of a summoner
            *
            * @param summonerId - ID of the summoner in question
            * @param region - (optional) region
            */
        getRanks(summonerId: string, region?: Regions): Promise<LeaguePosition[]>;
}

/**
    * Match Wrapper
    */
export interface MatchWrapper {
        /**
            * Gets the MatchList by accountID
            *
            * @param accountId - accountID of the summoner in question
            * @param region - (optional) region
            */
        getMatchList(accountId: string, region?: Regions): Promise<MatchList>;
}

/**
    * Status Wrapper
    */
export interface StatusWrapper {
        /**
            * Gets the status of a server
            *
            * @param region - (optional) region
            */
        getStatus(region?: Regions): Promise<Shard>;
}

/**
    * Summoner Wrapper
    */
export interface SummonerWrapper {
        /**
            * Gets the Summoner by accountID
            *
            * @param accountId - accountID of the summoner in question
            * @param region - (optional) region
            */
        getSummonerByAccountId(accountId: string, region?: Regions): Promise<Summoner>;
        /**
            * Gets the Summoner by summonerID
            *
            * @param summonerId - ID of the summoner in question
            * @param region - (optional) region
            */
        getSummonerById(summonerId: string, region?: Regions): Promise<Summoner>;
        /**
            * Gets the Summoner by name
            *
            * @param summonerName - name of the summoner in question
            * @param region - (optional) region
            */
        getSummonerByName(summonerName: string, region?: Regions): Promise<Summoner>;
}


/**
    * The TypeScript Riot API wrapper
    */
export default class JarvanScript {
        championMastery: ChampionMasteryWrapper;
        champion: ChampionWrapper;
        league: LeagueWrapper;
        match: MatchWrapper;
        summoner: SummonerWrapper;
        status: StatusWrapper;
        /**
            * creates a new wrapper instance
            *
            * @param key - the API key
            * @param region - the default region
            * @param config - the configuration
            */
        constructor(key: string, region: Regions, config?: object);
}

